package subprocess;

import java.util.HashMap;
import java.util.List;

import org.jbpm.api.Execution;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.task.Task;
import org.jbpm.pvm.internal.model.ExecutionImpl;
import org.jbpm.test.JbpmTestCase;


public class ComplateTaskTest extends JbpmTestCase {

  String deploymentId;
  String deploymentId2;
  
  protected void setUp() throws Exception {
 
    super.setUp();
  
    deploymentId = repositoryService.createDeployment()
    .addResourceFromClasspath("subprocess/PresenceWorkflow.jpdl.xml")
    .deploy();
    deploymentId2 = repositoryService.createDeployment()
    .addResourceFromClasspath("subprocess/waitForPresence.jpdl.xml")
    .deploy();
  }

  protected void tearDown() throws Exception {
    repositoryService.deleteDeploymentCascade(deploymentId);
    repositoryService.deleteDeploymentCascade(deploymentId2);
    super.tearDown();
  }
  
  public void testAddSubTasks() {
    
    HashMap<String, Object> vars = new HashMap<String, Object>();
    vars.put("user", "test");
    vars.put("timeoutPeriodMain", 5);
    vars.put("subinstanceidMain", "test");
    vars.put("TaskCompletionStatus", true);
    ProcessInstance pi = executionService.startProcessInstanceByKey("PresenceWorkflow", vars);
    
//    assertNotNull(pi.get);
    
    executionService.signalExecutionById(((ExecutionImpl)pi).getSubProcessInstance().getId());
    
    pi = executionService.findProcessInstanceById(pi.getId());
    executionService.signalExecutionById(pi.getId());
  }

}
